package org.cove.ape
{
   import flash.display.DisplayObject;
   import flash.display.Sprite;
   
   public class AbstractItem
   {
       
      
      internal var lineAlpha:Number;
      
      internal var lineColor:uint;
      
      internal var displayObjectOffset:Vector;
      
      internal var lineThickness:Number;
      
      internal var displayObject:DisplayObject;
      
      internal var fillAlpha:Number;
      
      private var _sprite:Sprite;
      
      internal var fillColor:uint;
      
      private var _visible:Boolean;
      
      private var _alwaysRepaint:Boolean;
      
      internal var displayObjectRotation:Number;
      
      public function AbstractItem()
      {
         super();
         _visible = true;
         _alwaysRepaint = false;
      }
      
      public function setLine(param1:Number = 0, param2:uint = 0, param3:Number = 1) : void
      {
         lineThickness = param1;
         lineColor = param2;
         lineAlpha = param3;
      }
      
      public function set visible(param1:Boolean) : void
      {
         _visible = param1;
         sprite.visible = param1;
      }
      
      public function setFill(param1:uint = 16777215, param2:Number = 1) : void
      {
         fillColor = param1;
         fillAlpha = param2;
      }
      
      public function init() : void
      {
      }
      
      public function get sprite() : Sprite
      {
         if(_sprite != null)
         {
            return _sprite;
         }
         if(APEngine.container == null)
         {
            throw new Error("The container property of the APEngine class has not been set");
         }
         _sprite = new Sprite();
         APEngine.container.addChild(_sprite);
         return _sprite;
      }
      
      public function paint() : void
      {
      }
      
      public function cleanup() : void
      {
         var _loc1_:int = 0;
         sprite.graphics.clear();
         _loc1_ = 0;
         while(_loc1_ < sprite.numChildren)
         {
            sprite.removeChildAt(_loc1_);
            _loc1_++;
         }
      }
      
      public function setStyle(param1:Number = 0, param2:uint = 0, param3:Number = 1, param4:uint = 16777215, param5:Number = 1) : void
      {
         setLine(param1,param2,param3);
         setFill(param4,param5);
      }
      
      public function get visible() : Boolean
      {
         return _visible;
      }
      
      final public function set alwaysRepaint(param1:Boolean) : void
      {
         _alwaysRepaint = param1;
      }
      
      final public function get alwaysRepaint() : Boolean
      {
         return _alwaysRepaint;
      }
   }
}
