package org.cove.ape
{
   public class CircleParticle extends AbstractParticle
   {
       
      
      private var _radius:Number;
      
      public function CircleParticle(param1:Number, param2:Number, param3:Number, param4:Boolean = false, param5:Number = 1, param6:Number = 0.3, param7:Number = 0)
      {
         super(param1,param2,param4,param5,param6,param7);
         _radius = param3;
      }
      
      internal function getIntervalX() : Interval
      {
         interval.min = curr.x - _radius;
         interval.max = curr.x + _radius;
         return interval;
      }
      
      internal function getIntervalY() : Interval
      {
         interval.min = curr.y - _radius;
         interval.max = curr.y + _radius;
         return interval;
      }
      
      override public function init() : void
      {
         cleanup();
         if(displayObject != null)
         {
            initDisplay();
         }
         else
         {
            sprite.graphics.clear();
            sprite.graphics.lineStyle(lineThickness,lineColor,lineAlpha);
            sprite.graphics.beginFill(fillColor,fillAlpha);
            sprite.graphics.drawCircle(0,0,radius);
            sprite.graphics.endFill();
         }
         paint();
      }
      
      public function set radius(param1:Number) : void
      {
         _radius = param1;
      }
      
      public function get radius() : Number
      {
         return _radius;
      }
      
      internal function getProjection(param1:Vector) : Interval
      {
         var _loc2_:Number = NaN;
         _loc2_ = Number(samp.dot(param1));
         interval.min = _loc2_ - _radius;
         interval.max = _loc2_ + _radius;
         return interval;
      }
      
      override public function paint() : void
      {
         sprite.x = curr.x;
         sprite.y = curr.y;
      }
   }
}
